use std::fs::read_to_string;
use std::io::Error;

fn main() -> Result<(), Error> {
    let mut max = 0;
    let mut all = Vec::new();
    let mut current = 0;

    for line in read_to_string("input.txt")?.split("\n") {
        if line == "" {
            if current >= max {
                max = current
            }
            all.push(current);
            current = 0
        } else {
            current += line.parse::<u32>().unwrap()
        }
    }
    if current >= max {
        max = current
    }
    all.push(current);

    all.sort_by(|a, b| b.cmp(a));

    println!("part 1: {}", max);
    println!("part 2: {}", all.iter().take(3).sum::<u32>());

    Ok(())
}
